Subject: Re: Kernel Panics in the network stack

From: Eric Dumazet <[email-masked]>
Date: Tue, 22 Dec 2009 12:32:23 +0100

Le 22/12/2009 12:08, Catalin Marinas a écrit :
> On Tue, 2009-12-22 at 10:09 +0000, Eric Dumazet wrote:
>> __switch_to:
>>
>> ...
>>         ldm r4, {r4, r5, r6, r7, r8, r9, sl, fp, sp, pc}
> 
> It looks to me like it is possible to get an interrupt after SP was
> loaded but before PC, the stack could be corrupted and PC would be
> loaded with garbage. One instance of your oops messages looks like PC
> corruption but the other may be caused by something else. What ARM CPU
> are you using?

I saw other very strange corruptions (registers R6 & R7) as well, on Kevin supplied traces.

> 
> I'm cc'ing Russell as well, it's strange that we haven't got any issue
> with this so far.

Oh well, it seems I CC'ed Rusty Russel instead :)

> 
> You could try #undef'ing __ARCH_WANT_INTERRUPTS_ON_CTXSW in
> arch/arm/include/asm/system.h as a sanity check for your aborts.
> 

Kevin uses linuxstamp card, from open circuits :

http://www.opencircuits.com/Linuxstamp

It's a AT91RM9200 processor (Arm9 with MMU, 180MHz )

Thanks